/*
	cstime.h

	% header for time and date functions

	written by John Cooke.

	C-scape 3.1
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 2/07/87 jdc	created
	 9/01/87 jmd 	added NO_PROTO option
	 9/15/87 jmd 	added _arg
	 8/07/89 jmd	removed time and date _funcs
*/

/* include time.h first */

#define		START_YEAR	0
#define		START_DAY	6L
#define		TM_OVERFLOW -2147483647L

/** global time data **/

OEXTERN int tm_daytab[2][13];

extern 	struct tm time_result;
extern	struct tm *result;

/** function prototypes **/

extern struct tm *tm_Now(_arg1(struct tm *));
extern boolean	  tm_IsValid(_arg1(struct tm *));
extern boolean 	  tm_IsTimeValid(_arg1(struct tm *));
extern boolean 	  tm_IsDateValid(_arg1(struct tm *));
extern struct tm *tm_Adjust(_arg1(struct tm *));
extern long 	  tm_ElapSecs(_arg2(struct tm *, struct tm *));
extern long		  tm_ElapDays(_arg2(struct tm *, struct tm *));
extern struct tm *tm_AddSecs(_arg2(struct tm *, long));
extern struct tm *tm_AddDays(_arg2(struct tm *, long));
extern int		  tm_Cmp(_arg2(struct tm *, struct tm *));
extern struct tm *tm_Copy(_arg2(struct tm *, struct tm *));
extern struct tm *tm_Zero(_arg1(struct tm *));

extern int 	      tm_DaysInMonth(_arg2(int month, int year));
extern int 		  tm_DayOfWeek(_arg3(int mday, int month, int year));

extern int		  tm_LeapYear(_arg1(int));

extern	boolean date_fexit(_arg1(sed_type));
extern	void 	date_senter(_arg2(sed_type, int));
extern	void 	date_sexit(_arg2(sed_type, int));
extern	void 	date_fkey(_arg1(sed_type));
extern	void	date_fenter(_arg1(sed_type));

extern  boolean	time_fexit(_arg1(sed_type));
extern	void 	time_senter(_arg2(sed_type, int));
extern	void 	time_sexit(_arg2(sed_type, int));
extern	void 	time_fkey(_arg1(sed_type));
extern	void	time_fenter(_arg1(sed_type));

/*** Global error strings ***/

extern char   *fndate_errmsg;		/* Used by date funcs (fndate.c) */
extern char   *fntime_errmsg;		/* Used by time funcs (fntime.c) */

/*** for date_funcs  ***/

#define	COUNTRY		 0
/*	adjusts style of date entry      	mm/dd/yy    USA = 0
										dd/mm/yy	EUR = 1
										yy/mm/dd	JAP = 2
*/
				
#define TIMEZONE	-5	/* EST */
/*	corrects for timezone is auto date and time entry	
	negative west of Greenwich, pos east
*/

#define DAYLIGHT	 1
/*	flag for daylight savings time correction
	1 = TRUE  (do correction)
	0 = FALSE (don't correct)
*/



