/*
	fnfunc.h

	% private header for field functions

	This file contains the definition for the
	functions contained in the field functions structures.

	C-scape 3.1
	Copyright (c) 1986-1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/


/*** misc utils ***/

extern char 	*strdecp(_arg2(char *, int));
extern char 	*strnodecp(_arg1(char *));
extern char 	*strcomma(_arg1(char *));
extern char 	*strnocomma(_arg1(char *));
extern char 	*strhex(_arg1(char *));
extern char		*strtrans(_arg3(char *, char, char));

/*** numeric funcs ***/

extern void		num_fenter(_arg1(sed_type));
extern void		num_fkey(_arg1(sed_type));

extern char    *strminus(_arg1(char *));
extern void 	clear_field(_arg1(sed_type));
extern int  	digit_count(_arg1(char *));

extern void		pnum_fkey(_arg1(sed_type));

/*** bob funcs ***/

extern void 	bob_fkey(_arg1(sed_type));

/*** int_funcs ***/

extern boolean 	int_fexit(_arg1(sed_type));
extern void 	int_senter(_arg2(sed_type, int));
extern void 	int_sexit(_arg2(sed_type, int));

/*** pint_funcs ***/


/*** hex_funcs ***/

extern boolean 	hex_fexit(_arg1(sed_type));
extern void 	hex_fkey(_arg1(sed_type));
extern void 	hex_senter(_arg2(sed_type, int));
extern void 	hex_sexit(_arg2(sed_type, int));

/*** long_funcs ***/

extern boolean 	long_fexit(_arg1(sed_type));
extern void 	long_senter(_arg2(sed_type, int));
extern void 	long_sexit(_arg2(sed_type, int));


/*** clong_funcs ***/

extern boolean 	clong_fexit(_arg1(sed_type));
extern void 	clong_fkey(_arg1(sed_type));
extern void 	clong_senter(_arg2(sed_type, int));
extern void 	clong_sexit(_arg2(sed_type, int));

/*** money_funcs ***/

extern boolean 	money_fexit(_arg1(sed_type));
extern void 	money_fkey(_arg1(sed_type));
extern void 	money_senter(_arg2(sed_type, int));
extern void 	money_sexit(_arg2(sed_type, int));

/*** cmoney_funcs ***/
extern boolean 	cmoney_fexit(_arg1(sed_type));
extern void 	cmoney_fkey(_arg1(sed_type));
extern void 	cmoney_senter(_arg2(sed_type, int));
extern void 	cmoney_sexit(_arg2(sed_type, int));

/*** string_funcs ***/

extern boolean 	string_fexit(_arg1(sed_type));
extern void 	string_fkey(_arg1(sed_type));
extern void 	string_senter(_arg2(sed_type, int));
extern void 	string_sexit(_arg2(sed_type, int));

/*** alpha_funcs ***/

extern void 	alpha_fkey(_arg1(sed_type));

/*** digit_funcs ***/

extern void 	digit_fkey(_arg1(sed_type));

/*** char_funcs ***/

extern boolean 	char_fexit(_arg1(sed_type));
extern void 	char_fkey(_arg1(sed_type));
extern void 	char_senter(_arg2(sed_type, int));
extern void 	char_sexit(_arg2(sed_type, int));

/*** double_funcs ***/

extern void 	double_fenter(_arg1(sed_type));
extern boolean 	double_fexit(_arg1(sed_type));
extern void 	double_fkey(_arg1(sed_type));
extern void 	double_senter(_arg2(sed_type, int));
extern void 	double_sexit(_arg2(sed_type, int));

/*** secure_funcs ***/

extern void 	secure_fkey(_arg1(sed_type));
extern void 	secure_senter(_arg2(sed_type, int));

/*** range_funcs ***/

extern void 	range_fkey(_arg1(sed_type));
extern void 	range_senter(_arg2(sed_type, int));

/*** yesno_funcs ***/

extern boolean 	yesno_fexit(_arg1(sed_type));
extern void 	yesno_fkey(_arg1(sed_type));
extern void 	yesno_senter(_arg2(sed_type, int));
extern void 	yesno_sexit(_arg2(sed_type, int));

/*** select_funcs ***/

extern void 	select_fkey(_arg1(sed_type));
extern void 	select_senter(_arg2(sed_type, int));

/*** menu_funcs ***/

extern void 	menu_fkey(_arg1(sed_type));

/*** gmenu_funcs ***/

extern void 	gmenu_fkey(_arg1(sed_type));

/*** sint_funcs ***/

extern void 	sint_fkey(_arg1(sed_type));
extern void 	sint_sexit(_arg2(sed_type, int));
extern void 	sint_senter(_arg2(sed_type, int));

/*** slong_funcs ***/

extern void 	slong_sexit(_arg2(sed_type, int));
extern void 	slong_senter(_arg2(sed_type, int));

/*** sfloat_funcs ***/

extern boolean 	sfloat_fexit(_arg1(sed_type));
extern void 	sfloat_sexit(_arg2(sed_type, int));
extern void 	sfloat_senter(_arg2(sed_type, int));

/*** sdouble_funcs ***/

extern void 	sdouble_fenter(_arg1(sed_type));
extern boolean 	sdouble_fexit(_arg1(sed_type));
extern void 	sdouble_fkey(_arg1(sed_type));
extern void 	sdouble_sexit(_arg2(sed_type, int));
extern void 	sdouble_senter(_arg2(sed_type, int));

/*** mark_funcs ***/

extern void 	mark_fkey(_arg1(sed_type));
extern void 	mark_sexit(_arg2(sed_type, int));
extern void 	mark_senter(_arg2(sed_type, int));

/*** check_funcs ***/

extern void 	check_fkey(_arg1(sed_type));
extern void 	check_sexit(_arg2(sed_type, int));
extern void 	check_senter(_arg2(sed_type, int));

/*** ticker_funcs ***/

extern void 	ticker_fkey(_arg1(sed_type));
extern void 	ticker_senter(_arg2(sed_type, int));

/*** xstring_funcs ***/

extern void 	xstring_fkey(_arg1(sed_type));

/*** toggle funcs ***/

extern void 	toggle_fkey(_arg1(sed_type));

/*** togint funcs ***/

extern void		togint_fkey(_arg1(sed_type));
extern void 	togint_senter(_arg2(sed_type, int));
extern void 	togint_sexit(_arg2(sed_type, int));

/*** list funcs ***/

extern void 	list_fkey(_arg1(sed_type));

/*** click funcs ***/

extern void 	click_fkey(_arg1(sed_type));
