/*
	fsym.c 	6/13/88  funcs list for use with sed files 

	% fsym_Find*

	C-scape 3.1
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 7/22/89 jdc	added fsym_FindNameFunc, fsym_FindNamePtr
	 8/08/89 jdc	added string_funcs return in fsym_FindPtr
	08/09/89 jdc	changed oslist_GetSym to oslist_Get
*/

#include "sed.h"
#include "fsymdecl.h"
#include "winspriv.h"

#include "fndecl.h"		/* for string_funcs */

char *fsym_FindNameFunc(list, fptr)
	oslist_type list;
	VOID_FPTR fptr;
/*
*/
{
	unsigned int i;
	char *name;

	if (list != NULL) {
		for (i = 0; i < oslist_GetSize(list); i++) {

			name = oslist_Get(list, oslist_AlphaHandle(list, i));
			if (fptr == *((VOID_FPTR *)sym_GetData(name))) {
				return(name);
			}
		}
	}
	return(NULL);
}
	
char *fsym_FindNamePtr(list, ptr)
	oslist_type list;
	VOID *ptr;
/*
*/
{
	unsigned int i;
	char *name;

	if (list != NULL) {
		for (i = 0; i < oslist_GetSize(list); i++) {

			name = oslist_Get(list, oslist_AlphaHandle(list, i));
			if (ptr == *((VOID **)sym_GetData(name))) {
				return(name);
			}
		}
	}
	return(NULL);
}

VOID_FPTR fsym_FindFunc(list, name, handlep)
	oslist_type list;
	char *name;
	int *handlep;
{
	char *data;

	if (list != NULL) {
		if ( (*handlep = oslist_FindSymHandle(list, name)) != OSLIST_BADNAME ) {

			data = sym_GetData(oslist_Get(list, *handlep));
			return(*((VOID_FPTR *)data));
		}
	}
	return(FNULL);
}

VOID *fsym_FindPtr(list, name, handlep)
	oslist_type list;
	char *name;
	int *handlep;
{
	char *data;

	if (list != NULL) {
		if ( (*handlep = oslist_FindSymHandle(list, name)) != OSLIST_BADNAME ) {

			data = sym_GetData(oslist_Get(list, *handlep));
			return(*((VOID **)data));
		}
	}
	return((VOID *)&string_funcs);
}

