/*
  	idleclk.c	11/05/88

	% idle_Clock

	Keyboard Idle clock function.

	Places a clock window in the bottom ot the display 

	C-scape 3.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 7/24/89 gam	Fixed for mouse. Now paints only when necessary
*/

#include <stdio.h>

#include "cscape.h"

#include <time.h>
#include "cstime.h"

#include "kbidle.h"

void idle_Clock(msg)
	int msg;
/*
	Places a clock in a window.	
*/
{
	menu_type menu;
	static sed_type timesed = NULL;
	static struct tm t;
	static short oldsec;

	switch (msg) {
	case IDLE_START:
		/* create timesed */
		/* this is called when kb_Idle first sets up the idle func */
		menu = menu_Open();
		menu_Printf(menu, "@f[##:##:##]", &t, &time_funcs);
		menu_Flush(menu);

		timesed = sed_Open(menu);
		sed_SetPosition(timesed, disp_GetHeight() - 1, disp_GetWidth() - 10);

		/* Get current time */
		tm_Now(&t);
		oldsec = (short)t.tm_sec;

		/* Paint the sed */
		sed_Repaint(timesed);
		break;

	case IDLE_RUN:
		/* Get current time */
		tm_Now(&t);

		/* Paint the field */
		if (oldsec != t.tm_sec) {
			oldsec = (short)t.tm_sec;
			sed_RepaintField(timesed, 0);
		}

		/* Make sure window is visible */
		sed_Top(timesed);
		break;

	case IDLE_STOP:
		/* Destroy the sed */
		sed_Close(timesed);
		break;
	}
}
