/*
	menuifld.c	 4/10/88

	% menu_InsertRows

	C-scape 3.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 6/07/88 jmd	added call to tb_InsertRow
	 6/24/88 jmd	converted to new xarray/iarray calls

	 4/16/89 jmd 	adjusted for jarray
	07/02/89 jdc	added frowcount change
*/

#include "menu.h"

boolean menu_InsertRows(menu, row, count)
	menu_type menu;
	int row;
	int count;
/*
	Inserts count rows in the menu before row.
*/
{
	register int 	i;
	int 	 fno;

	/* test menu and row number */
	cs_Assert(menu_Ok(menu), CS_M_IR_MENU, 0);	/* passed bad menu */
	cs_Assert(row >= 0 && row < menu_GetRowCount(menu) && count > 0, CS_M_IR_ARG, 0);	/* passed bad args */

	/* insert rows into the text buffer */
	for (i = 0; i < count; i++) {
		menu_InsRowTB(menu, row, 0);
	}

	/* slide the row array */
	/* adjust the row position for all the fields below */
	for (i = menu->frowcount - 1; i >= row; i--) {
		fno = ia_Get(menu->fgrid, i);
		ia_Put(menu->fgrid, i + count, fno);
		if (fno > 0) {
			for (fno = fno - 1; fno >= 0; fno = menu_GetFieldRight(menu, fno)) {
				field_SetRow(menu_GetField(menu, fno), i + count);
			}
		}
	}
	menu->frowcount += count;

	/* clear the inserted area of the row array */
	fno = 0;
	for (i = row; i < row + count; i++) {
		ia_Put((menu)->fgrid, i, fno);
	}

	/* menu size is now incorrect */
	menu_SetDirty(menu, TRUE);

	return(TRUE);
}

