/*
	menuname.c

	% menu field name routines

	A name contains an integer (fieldno) and a string in one buffer.

	C-scape 3.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/04/89 jdc	rewrote for non class function symbols
	 8/09/89 jdc	changed oslist_GetSym to oslist_Get

*/

#include "menu.h"

int menu_AddName(menu, name, fieldno)
	menu_type menu;
	char *name;
	int fieldno;
/*
	Add a name to the menu's name list.
	return a handle to the name.
	Initialize the name first time called.
	Returns -1 if it fails.
*/
{
	int nameno;

	if ( menu->namelist == NULL ) {
		/* create name array */
		if ( (menu->namelist = oslist_Open(4, sizeof(int))) == NULL ) {
			return(-1);
		}
	}
	nameno = oslist_Put(menu->namelist, name, (VOID *)(&fieldno));
	
	return(nameno);
}

void menu_SetFieldName(menu, fieldno, name)
	menu_type menu;
	int fieldno;
	char *name;
/*
	Set a field's name name.
*/
{
	int nameno;

	if ( (nameno = menu_GetFieldNameNo(menu, fieldno)) != -1 ) {
		/* remove old name */
		menu_RemoveName(menu, nameno);
	}
	/* add name */
	nameno = menu_AddName(menu, name, fieldno);
	menu_SetFieldNameNo(menu, fieldno, nameno);
}

int menu_GetNameNo(menu, name)
	menu_type menu;
	char *name;
{
	int h;

	if ( (h = oslist_FindSymHandle(menu->namelist, name)) == OSLIST_BADNAME ) {
		return(-1);
	}
	return( *((int *)sym_GetData(oslist_Get(menu->namelist, h))) );
}
