/* 
	msys.c

	% msys menu system routines

	C-scape 3.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
 	 8/30/88 jdc	created
	11/05/88 jmd	removed menu_Close
	11/30/88 jmd	Modified UFUNCBOB case in msys_GoBob
	12/11/88 jmd	moved idata to ufunc _od

	 6/23/89 jmd	added GotoFirstField in msys_GoBob
	 8/21/89 jmd	added bob_IsWin to msys_RepaintBob
	 9/10/89 jmd	re-wrote msys_dir
	 9/11/89 jmd	added win_Top to msys_RepaintBob
*/

#include <stdio.h>
#include <ctype.h>

#include "cscape.h"
#include "oaktag.h"				/* For IDs in msys.h */
#include "msys.h"

void msys_Repaint(sed, row, col)
	sed_type sed;
	int row, col;
/*
*/
{
	if (row != -1 && col != -1) {
		sed_SetPosition(sed, row, col);
	}

	sed_Repaint(sed);
}

int msys_Go(sed, start, row, col, data)
	sed_type sed;
	int start, row, col;
	VOID *data;
/*
*/
{
	sed_SetData(sed, data);

	if (row != -1 && col != -1) {
		bord_SetPosition(sed, row, col);
	}

	if (start != -1 ) {		   /* upon original entry */
		sed_GotoField(sed, start);
	}

	return(sed_Go(sed));
}

void msys_RepaintBob(sed, row, col)
	sed_type sed;
	int row, col;
{
	bob_type bob;

	if ((bob = sed_GetFieldBob(sed, sed_GetFieldNo(sed))) != NULL ) {

		if (bob_IsWin(bob)) {
		    if (row != -1 && col != -1 ) {
				bord_SetPosition(bob, row, col);
			}

			/* repaint the bob */
			bob_Do(bob, WINM_PAINTREQ, NULL, NULL);

			/* top the bob, just in case */
			win_Top(bob);
		}
	}
}

int msys_GoBob(sed, row, col)
	sed_type sed;
	int row, col;
/*
	Sends GO msg to the current field's bob.
	Handles SEDBOBs and UFUNCBOBs specially.
*/
{
	bob_type 	bob;
	int 		ret = 0;
	boolean		isased;
 	
	/* Note: every field should have a bob attached to it */

	if ((bob = sed_GetFieldBob(sed, sed_GetFieldNo(sed))) != NULL ) {

	    if (!bob_IsUfunc(bob) && row != -1 && col != -1 ) {
			bord_SetPosition(bob, row, col);
		}

		if ((isased = bob_IsSed(bob)) == TRUE) {
			sed_SetData(bob, sed_GetData(sed));
			sed_GotoFirstField(bob);
		}

		bob_Do(bob, WINM_GOREQ, sed_GetData(sed), &ret);

		if (isased) {
			sed_SetBaton(bob, 0);
		}
	}

	return(ret);
}

int msys_dir(sed)
	sed_type sed;
/*
	Determines the orientation of a sed
	returns either MENU_HORIZONTAL or MENU_VERTICAL
*/
{
	if (sed_GetFieldCount(sed) <= 1  || sed_GetGridField(sed, 0, 1) > 0) {
		return(MENU_HORIZONTAL);
	}
	else {
		return(MENU_VERTICAL);
	}
}
