/*
  	msys.h

	% Header for menuing systems.

	C-scape 3.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/30/88 jdc	Created
	10/17/88 jmd	Added _arg, preened
	11/30/88 jmd	Fixed spelling of vertical
	12/20/88 jmd    removed mouse handler

	 2/02/89 jdc	fixed frame_Unlock bug
	 7/26/89 jmd	made frame_Lock a function
					removed msys_Lock (it should be made a function)
	 9/10/89 jmd	re-wrote msys_dir
*/

#include "ufuncobj.h"

OEXTERN field_funcs_struct  slug_funcs;
OEXTERN field_funcs_struct  framer_funcs;

extern void 	slug_fenter(_arg1(sed_type));
extern boolean	slug_fexit(_arg1(sed_type));
extern void		slug_fkey(_arg1(sed_type));

extern void 	framer_fenter(_arg1(sed_type));
extern boolean	framer_fexit(_arg1(sed_type));
extern void		framer_fkey(_arg1(sed_type));

typedef sed_type slug_type;
typedef sed_type frame_type;

/* SLUG definitions */

struct slug_list {
	char 		*choice;
	char 		*message;
	struct 		slug_list *child;
	ufunc_fptr 	slug_func;
	int  		value;
};

#define SLUG_VERTICAL   	MENU_VERTICAL
#define SLUG_HORIZONTAL 	MENU_HORIZONTAL

#define slug_Open(slist, dir, bord, bkclr, slclr, bdclr) \
 	slug_create(slist, dir, bord, bkclr, slclr, bdclr, 0, 0, &slug_funcs, NULL)

#define fram_SlugOpen(slist, dir, bord, bkcol, slcol, bdcol) \
 	slug_create(slist, dir, bord, bkcol, slcol, bdcol, 0, 0, &framer_funcs, NULL)

#define slug_Repaint(sed, row, col) 		msys_Repaint(sed, row, col)
#define slug_Close(sed) 					sed_Close(sed)

/* FRAMER definitions */

struct frame_def {
	char 		*choice;
	ufunc_fptr	frame_func;
	int  		value;
};

#define FRAME_END	NULL, FNULL, 0

#define frame_Open(frame_list, bd, bkg, sel, bdc) \
	frame_create(frame_list, MENU_HORIZONTAL, bd, bkg, sel, bdc, 0, 0, &framer_funcs, sedmou_Framer)

#define slug_FrameOpen(frame_list, dir, bd, bkg, sel, bdc) \
	frame_create(frame_list, dir, bd, bkg, sel, bdc, 0, 0, &slug_funcs, NULL)

#define frame_Repaint(sed)			 		msys_Repaint(sed, -1, -1)
#define frame_SetPosition(sed, row, col)    sed_SetPosition(sed, row, col)
#define frame_Close(sed) 					sed_Close(sed)

#define frame_UnLock(sed, family, member) \
			frame_do(sed, MSYS_UNLOCK, family, member, NULL)


#define frame_IsLocked(sed, family, member) \
			frame_do(sed, MSYS_ISLOCKED, family, member, NULL)

#define frame_SetBob(sed, family, member, bob) \
			frame_do(sed, MSYS_SETBOB, family, member, (VOID *)bob)

/* NMENU definitions */

#define MENU_VERTICAL   1
#define MENU_HORIZONTAL 2

#define MSYS_LOCK		1
#define MSYS_UNLOCK		2
#define MSYS_ISLOCKED	3
#define MSYS_SETBOB		4
#define MSYS_GETBOB		5

#define msys_FieldBobExists(sed)  \
	(sed_GetFieldBob(sed, sed_GetFieldNo(sed)) != NULL)

#define msys_FieldBobIsUfunc(sed) \
	(sed_GetFieldBob(sed, sed_GetFieldNo(sed)) == NULL || obj_GetId(sed_GetFieldBob(sed, sed_GetFieldNo(sed))) == ID_UFUNC)

#define msys_PopBob(sed) \
	((msys_FieldBobExists(sed)) ? win_UnEmploy(sed_GetFieldBob(sed, sed_GetFieldNo(sed))) : 0)


#define msys_UnLock(sed, code) 		msys_do(sed, MSYS_UNLOCK, code, NULL)
#define msys_IsLocked(sed, code) 	msys_do(sed, MSYS_ISLOCKED, code, NULL)
#define msys_SetBob(sed, code, bob)	msys_do(sed, MSYS_SETBOB, code, (VOID *)bob)
#define msys_GetBob(s, c, bobp)		msys_do(sed, MSYS_GETBOB, code, (VOID *)bobp)

extern sed_type slug_create(_arg10(struct slug_list[], int, bd_fptr, byte, byte, byte, int, int, field_funcs_ptr, mouhandler_fptr));
extern int		slug_Go(_arg5(sed_type, int, int, int, VOID *));

extern sed_type frame_create(_arg10(struct frame_def[], int, bd_fptr, byte, byte, byte, int, int, field_funcs_ptr, mouhandler_fptr));
extern int		frame_Go(_arg3(sed_type, int, VOID *));
extern boolean	frame_do(_arg5(sed_type, int, int, int, VOID *));

extern boolean	frame_Lock(_arg4(sed_type, int, int, byte));

extern void		msys_Repaint(_arg3(sed_type, int, int));
extern int		msys_Go(_arg5(sed_type, int, int, int, VOID *));
extern boolean	msys_do(_arg4(sed_type, int, int*, VOID *));

extern void		msys_RepaintBob(_arg3(sed_type, int, int));
extern int		msys_GoBob(_arg3(sed_type, int, int));
extern int		msys_dir(_arg1(sed_type));


