/* 
	msysdo.c

	% msys_do

	C-scape 3.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
 	11/25/88 jdc	created
	 6/01/89 jdc	added MSYS_GETBOB message
	 7/15/89 ted	Moved cast to right side in 'data = sed_GetFieldBob'.
	 7/26/89 jmd	LOCK message is now passed a (byte *)
*/

#include <stdio.h>
#include <ctype.h>

#include "cscape.h"
#include "oaktag.h"				/* For IDs in msys.h */
#include "msys.h"

boolean msys_do(sed, msg, code, data)
	sed_type sed;
	int msg;
	int *code;
	VOID *data;
/*
*/
{
	int i;
	bob_type bob;
	boolean ret = TRUE;
	
	if (code[0] == -1) {
		return(FALSE);
	}

	for (i = 0; code[i+1] >= 0; i++) {
		if ((bob = sed_GetFieldBob(sed, code[i])) == NULL 
			|| obj_GetId(bob) != ID_SEDWIN) {
		
			return(FALSE);
		}
	}

	if (code[i] >= sed_GetFieldCount(bob)) {
		return(FALSE);
	}

	switch (msg) {
	case MSYS_LOCK:
		sed_ProtectField(bob, code[i]);
		sed_MarkField(bob, code[i], *((byte *) data), *((byte *) data));
		sed_UpdateField(bob, code[i]);
		break;
	case MSYS_UNLOCK:
		sed_UnProtectField(bob, code[i]);
		sed_UnMarkField(bob, code[i]);
		sed_UpdateField(bob, code[i]);
		break;
	case MSYS_ISLOCKED:
		ret = sed_IsProtectedField(bob, code[i]);
		break;
	case MSYS_SETBOB:
		sed_SetFieldBob(bob, code[i], (bob_type)data);
		break;	
	case MSYS_GETBOB:
		data = (VOID *) sed_GetFieldBob(bob, code[i]);
		break;	
	}

	return(ret);
} 

