/*
	objload.c

	% sfile_LoadObj, sfile_SaveObj

	C-scape 3.1
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

#include <time.h>

#include "sed.h"
#include "sfile.h"
#include "sfilpriv.h"
#include "teddecl.h"
#include "sled.h"

sed_type sfile_LoadObj(sfile, name)
	sfile_type	sfile;
	char		*name;
{
	obj_type obj;

	if (oslist_FindSymHandle(sfile->bfile->dir, name) == -1
		|| !sfile_Find(sfile, name, ID_LNFWIN)) {

		return(NULL);
	}
	if ((obj = sf_loadobj(sfile)) != NULL) {

		/* extra info: time stamp */
		_bfile_gets(sfile->bfile, sfile->buf, SFILE_BUFLEN, '\0');
	}
	return(obj);
}

obj_type sf_loadobj(sfile)
	sfile_type	sfile;
{
	obj_type obj;
 	class_fptr class;
	int handle;

	_bfile_gets(sfile->bfile, sfile->buf, SFILE_BUFLEN, '\0');

	if ((class = sfile_FindClassFunc(sfile, sfile->buf, &handle)) == FNULL
		|| (obj = obj_Open(class, NULL)) == NULL) {

		return(NULL);
	}	
	obj_Do(obj, OBJM_LOAD, sfile, NULL);

	return(obj);
}

boolean sfile_SaveObj(sfile, obj, name)
	sfile_type	sfile;
	obj_type 	obj;
	char		*name;
{
	boolean ret;
	TIME_T timep;

	if (!sfile_Find(sfile, name, ID_LNFWIN)) {
		return(FALSE);
	}
	if ((ret = sf_saveobj(sfile, obj)) == TRUE) {

		/* extra info: time stamp */
		sprintf(sfile->buf, "%ld\n", time(&timep));	
		bfile_Write(sfile->bfile, sfile->buf, strlen(sfile->buf));
	}
	return(ret);
}

boolean sf_saveobj(sfile, obj)
	sfile_type sfile;
	obj_type obj;
{
	sprintf(sfile->buf, "%s\n", obj_GetClassName(obj, sfile));

	bfile_Write(sfile->bfile, fsym_NullCheck(sfile->buf), strlen(sfile->buf));

	return(obj_Do(obj, OBJM_SAVE, sfile, NULL));
}
