/*
  	puedit.c	9/16/88

	% pop_Edit

	Popup editor.

	C-scape 3.1
	Copyright (c) 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/05/88 jmd	removed menu_Close
	11/19/88 jmd	now uses ted_funcs

	 4/22/89 jmd	changed border to bord
	 9/07/89 jmd	fixed default size trouble
*/

#include <stdio.h>

#include "cscape.h"
#include "strdecl.h"			/* for invert_char() */
#include "teddecl.h"
#include "popdecl.h"

void pop_Edit(title, text, tlen, row, col, height, width, color, label, bord)
	char *title;
	char *text;
	unsigned tlen;
	int  row, col;
	int  height, width;
	byte color;
	int  label;
	bd_fptr bord;
/*
	Places text in a window.

	The text can be edited.

	Exits when ESC is pressed.

	standard use of row, col etc...
*/
{
	sed_type   sed;
	menu_type  menu;

	if ((menu = menu_Open()) == NULL) {
		return;
	}

	if (!menu_Printf(menu, "@f[]", text, &ted_funcs)) {
		menu_Destroy(menu);
		return;
	}

	menu_Flush(menu);	
	if ((sed = sed_Open(menu)) == NULL) {
		menu_Destroy(menu);
		return;
	}

	sed_SetColors(sed, color, color, invert_char(color) & 0x7f);
	sed_SetBorder(sed, bord);
	sed_SetLabel(sed, label);

	/* pre-adjust for pop_Parms */
	height = (height < 0) ? DEFAULT_HEIGHT : height;
	width  = (width  < 0) ? DEFAULT_WIDTH  : width;

	pop_SetParms(sed, row, col, height, width, title);

	/* set ted parameters */
	ted_SetWrapWidth(sed, sed_GetWidth(sed) - 1);
	ted_SetInsert(sed, TED_INSERT);
	ted_SetMoveMethod(sed, ted_Follow);
	ted_SetMaxSize(sed, (long) tlen);

	/* put up the sed */
	sed_Repaint(sed);
	sed_Go(sed);

	/* close the sed */
	sed_Close(sed);
}
	

