/*
	pumsg.c     	1/27/87

	% pop_Message

	popup message routine.

	C-scape 3.1
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/22/88 jmd	Added cursor type restoration.
	 7/22/88 jmd	Removed cursor type restoration.
					Made it work with windows.
	 8/23/88 jmd	Fixed wrap width.
	 9/16/88 jmd	updated for 3.0
	11/05/88 jmd	removed menu_Close

	 4/22/89 jmd	changed border to bord
*/

#include <stdio.h>

#include "cscape.h"
#include "scancode.h"
#include "popdecl.h"

void pop_Message(msg, row, col, height, width, color, bord)
	char *msg;
	int  row, col;
	int  height, width;
	byte color;
	bd_fptr bord;
/*
	Puts up a message in a box and returns.

	If msg is NULL then it clears the previous message.
*/
{
	static sed_type sed = NULL;    
	menu_type		menu;

	if (sed != NULL) {
		/* clear the old message first */
		sed_Close(sed);
		sed = NULL;
	}

	if (msg == NULL) {
		return;
	}

	if ((menu = menu_Open()) == NULL) {
		return;
	}

	if (!menu_Printf(menu, msg)) {
		menu_Destroy(menu);
		return;
	}

	menu_SetWrapWidth(menu, (width > 0) ? width : DEFAULT_WIDTH);
	menu_Flush(menu);

	if ((sed = sed_Open(menu)) == NULL) {
		menu_Destroy(menu);
		return;
	}

	sed_SetColors(sed, color, color, color);
	sed_SetBorder(sed, bord);
	pop_SetParms(sed, row, col, height, width, NULL);

	sed_Repaint(sed);
}


