/*
  	puparms.c

	% pop_SetParms

	C-scape 3.1
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 9/15/88 jmd	changed vid_ to disp_
	 9/16/88 jmd	updated for 3.0
*/

#include <stdio.h>

#include "cscape.h"
#include "scancode.h"
#include "popdecl.h"

void pop_SetParms(sed, row, col, height, width, title)
	sed_type sed;
	int row, col, height, width;
	char *title;
/*
	Adjusts the parameters for pop up boxes.

	If any of these arguments (row, col, height, width) are 	
	negative default values are used  (centered).
*/
{
	if (width > 0) {
		sed_SetWidth(sed, width);
	}
	else if (sed_GetWidth(sed) > DEFAULT_WIDTH) {
		sed_SetWidth(sed, DEFAULT_WIDTH);
	}

	if (height > 0)  {
		sed_SetHeight(sed, height);
	}
	else if (sed_GetHeight(sed) > DEFAULT_HEIGHT) {
		sed_SetHeight(sed, DEFAULT_HEIGHT);
	}

	/* set up the title before centering */
	if (title != NULL) {
		sed_SetBorderTitle(sed, title);
	}

	/* set up the position */
	if (row < 0) {
		row = disp_GetHeight()/2 - sed_GetBorderHeight(sed)/2;
		row = (row < 0) ? 0 : row;
	}

	if (col < 0) {
		col = disp_GetWidth()/2 - sed_GetBorderWidth(sed)/2;
		col = (col < 0) ? 0 : col;
	}

	sed_SetPosition(sed, row, col);
}
