/*
	puprompt.c     	7/25/86

	% pop_Prompt

	Popup prompt function.

	C-scape 3.1
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 9/16/88 jmd	updated for 3.0
	11/05/88 jmd	removed menu_Close

	 4/22/89 jmd	changed border to bord
*/

#include <stdio.h>

#include "cscape.h"
#include "scancode.h"
#include "popdecl.h"

void pop_Prompt(msg, row, col, height, width, color, bord)
	char *msg;
	int  row, col;
	int  height, width;
	byte color;
	bd_fptr bord;
/*
	Puts up a message in a box.
	Waits for ESC to be pressed.
*/
{
	menu_type   menu;
	sed_type    sed;

	if ((menu = menu_Open()) == NULL) {
		return;
	}
	if (!menu_Printf(menu, msg)) {
		menu_Destroy(menu);
		return;
	}
	menu_SetWrapWidth(menu, (width > 0) ? width : DEFAULT_WIDTH);

	if ( !menu_Printf(menu, 
		"@p[%d,%d]Press ESC", 
		menu_GetHeight(menu) + 1,
		menu_GetWrapWidth(menu) / 2 - 5)) {

		menu_Destroy(menu);
		return;
	}
	menu_Flush(menu);

	if ((sed = sed_Open(menu)) == NULL) {
		menu_Destroy(menu);
		return;
	}
	sed_SetColors(sed, color, color, color);
	sed_SetBorder(sed, bord);
	pop_SetParms(sed, row, col, height, width, NULL);

	sed_SetCursorType(sed, CURSOR_NONE);
	sed_Repaint(sed);

	/* wait for ESC to be pressed */
	while(kb_Read() != ESC)
		;

	sed_Close(sed);
}














