/*
	putext.c     	7/22/88

	% pop_Text

	popup text routine.

	C-scape 3.1
	Copyright (c) 1986, 1987, 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/23/88 jmd	Fixed wrap width.
	 9/16/88 jmd	updated for 3.0
	11/05/88 jmd	removed menu_Close

	 4/22/89 jmd	changed border to bord
*/

#include <stdio.h>

#include "cscape.h"
#include "scancode.h"
#include "popdecl.h"

sed_type pop_Text(msg, row, col, height, width, color, bord)
	char *msg;
	int  row, col;
	int  height, width;
	byte color;
	bd_fptr bord;
/*
	Puts up a message in a box and returns a handle to the message.

	The message can be removed by calling sed_Close.
*/
{
	sed_type 		sed;    
	menu_type		menu;

	if (msg == NULL) {
		return(NULL);
	}

	if ((menu = menu_Open()) == NULL) {
		return(NULL);
	}

	if (!menu_Printf(menu, msg)) {
		menu_Destroy(menu);
		return(NULL);
	}
	menu_SetWrapWidth(menu, (width > 0) ? width : DEFAULT_WIDTH);
	menu_Flush(menu);

	if ((sed = sed_Open(menu)) == NULL) {
		menu_Destroy(menu);
		return(NULL);
	}

	sed_SetColors(sed, color, color, color);
	sed_SetBorder(sed, bord);
	pop_SetParms(sed, row, col, height, width, NULL);

	sed_Repaint(sed);

	return(sed);
}

