/*
	sdalloc.c	jdc	10/27/88

	% sed_Alloc

	C-scape 3.1
	Copyright (c) 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	---------------------
	 4/28/89 jdc	preened
	 6/21/89 jmd	made a boolean, added comments
	 7/06/89 jdc	varsize == 0 var now gets set to NULL (VAR_TED case)
	 8/14/89 jdc	added bob support
*/

#include "sed.h"
#include "sfile.h"

boolean sd_alloc(sed, bobs)
	sed_type sed;
	boolean bobs;
/*
	Allocate space for a sed's variables.
	Returns FALSE if it fails.
*/
{
	int i;
	unsigned int size;
 	char *data;

	/* if we've already allocated storage, release it */
	if (sed_GetMenu(sed)->varblock != NULL) {
		ofree(CSA_VARBLOCK, (VOID *) sed_GetMenu(sed)->varblock);
		sed_GetMenu(sed)->varblock = NULL;
	}

	/* figure out how much space we need */
	for (i = 0, size = 0; i < sed_GetFieldCount(sed); i++) {
		size += sed_GetVarSize(sed, i);
	}

	if (size == 0) {
		return(TRUE);
	}

	/* allocate the space */
	if ((sed_GetMenu(sed)->varblock = (VOID *) ocalloc(CSA_VARBLOCK, 1, size)) == NULL) {
		return(FALSE);
	}

	/* point the field variables to the space */
	for (i = 0, data = (char *)(sed_GetMenu(sed)->varblock); i < sed_GetFieldCount(sed); i++) {
		if ((size = sed_GetVarSize(sed, i)) == 0) {
			sed_SetVar(sed, i, NULL);
		}
		else {
			sed_SetVar(sed, i, (VOID *)data);
		}
		data += size;
	}

	for (i = 0; i < sed_GetMenu(sed)->bobcount; i++) {
		if (bobs &&
		obj_Who(sed_GetFieldBob(sed, ia_Get(sed_GetMenu(sed)->boba, i)), ID_SEDWIN)) {

			sd_alloc(sed, bobs);
		}
	}

	return(TRUE);
}

