/*
	sdbobown.c		

	% bob_GetOwner

	C-scape 3.1
	Copyright (c) 1989, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/08/89 jmd 	made a separate file
	 8/21/89 jmd 	fixed GP fault bug
*/

#include "sed.h"

sed_type bob_GetOwner(bob, fldnop)
	bob_type bob;
	int *fldnop;
/*
	Returns the sed to which the sed is attached
	Places the field number to the bob is attached in fieldnop
	returns NULL if the bob is not attached to something
*/
{
	sed_type sed;
	menu_type menu;
	register int i;

	/* Get the parent sed */
	if (bob != NULL && ((sed = bob_GetParent(bob)) != NULL)) {

		if (obj_GetId(sed) == ID_SEDWIN) {
			menu = sed_GetMenu(sed);

			/* Find the field number */
			for (i = 0; i < menu_GetBobCount(menu); i++) {
				if (bob == menu_GetBob(menu, i)) {
					*fldnop = menu_GetBobFieldNo(menu, i);
					return(sed);
				}
			}
		}
	}

	return(NULL);
}

