/*
	sdincchr.c

	% sed_IncChar

	C-scape 3.1
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/05/86 jmd	converted to boolean
	11/18/87 jmd 	changed names of some low-level funcs
	 4/11/88 jmd	added scrollable field handling

	 3/24/89 jmd	added sed_ macros
*/

#include "sed.h"

boolean sed_IncChar(sed)
	sed_type sed;
/*                                        
	requires:   sed object.

	modifies:   same.

	effects:    goes to the next character in the field.  doesn't wrap 
				around.
*/
{
	int i;

	cs_Assert(sed_Ok(sed), CS_SD_IC_SED, 0);

	if (sed_GetRecordPos(sed) == NO_WRITEABLES) {
		return(FALSE);
	}
	else {
		i = menu_GetNextFieldPos(sed_GetMenu(sed), sed_GetFieldNo(sed), sed_GetRecordPos(sed));
	   
		if (i == AT_END) {
			return(FALSE);
		}
		else {
			if (sd_goto_char(sed, i)) {
				/* field scrolled, repaint it */
				sd_refresh_field(sed, sed_GetFieldNo(sed));
			}
		}
	}
	return(TRUE);
}


