/*
	sdload.c

	% sfile_LoadSed, sf_loadsed, sf_savesed

	C-scape 3.1
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/21/89 jdc	added bord_Do(sed, BDM_SCROLL) fixes lights
	 8/31/89 jmd	removed long ifdefs
*/

#include "sed.h"
#include "sfile.h"
#include "sfilpriv.h"
#include "sedwinod.h"
#include "ufuncobj.h"
#include "teddecl.h"

OSTATIC objreq_func (sdwinreq_load);

void sedwin_LoadInit()
{
	sdwinreq_loadfptr = sdwinreq_load;
	win_LoadInit();
	ufunc_LoadInit();
}

sed_type sfile_LoadSed(sfile, name, allocate)
	sfile_type	sfile;
	char		*name;
	boolean		allocate;
{
	sedwin_LoadInit();

	sfile->alloc = allocate;

	return(sfile_LoadObj(sfile, name));
}

OSTATIC VOID_FPTR null_funcptr = FNULL;

int sdwinreq_load(objdata, msg, indata, outdata)
	VOID *objdata;
	int msg;				/* message */
	VOID *indata;			/* message input data */
	VOID *outdata;			/* message output data */
{
	sed_type sed;
	sfile_type sfile;

	int back, fore, high, label;
	int handle, is_lnf;
	menu_type menu;
	move_method move;
	bfile_type bfile;
	char *sbuf;

	oak_notused(outdata);
	oak_notused(msg);

	sed = sedod_GetSelf((sedwin_od *)objdata);
	sfile = (sfile_type)indata;

	if (!win_DoRaw(&((sedwin_od *)objdata)->wd, msg, indata, outdata)) {
		return(FALSE);
	}

	bfile = sfile->bfile;
	sbuf = sfile->buf;

	is_lnf = (sfile->oslist_array[FSYM_TY] == NULL) ? FALSE:TRUE;

	if ((menu = sf_loadmenu(sfile)) == NULL) {
		return(FALSE);
	}
	sed_Init(sed, menu);

	/* sed info:
		label, back, fore, high, move method, special, ox
	*/
	if (_bfile_gets(bfile, sbuf, SFILE_BUFLEN, '\0') == 0) {
		return(FALSE);
	}
	sscanf(sbuf, "%d %d %d %d", &label, &back, &fore, &high);

	sed_SetColors(sed, (byte)fore, (byte)back, (byte)high);
	sed_SetLabel(sed, label);

/* move method */
	if (_bfile_gets(bfile, sbuf, SFILE_BUFLEN, '\0') == 0) {
		goto ERROR;
	}
	move = sfile_FindMoveMethodFunc(sfile, sbuf, &handle);
	ted_SetMoveMethod(sed, move);
	if (is_lnf) {
		if (handle == -1) {
			handle = sfile_PutMoveMethodFunc(sfile, sbuf, null_funcptr);
		}
		menu_SetMoveMethodHandle(menu, handle);
	}

/* special */
	if (_bfile_gets(bfile, sbuf, SFILE_BUFLEN, '\0') == 0) {
		goto ERROR;
	}
	sed_SetSpecial(sed, sfile_FindSpecialFunc(sfile, sbuf, &handle));
	if (is_lnf) {
		if (handle == -1) {
			handle = sfile_PutSpecialFunc(sfile, sbuf, null_funcptr);
		}
		menu_SetSpecialHandle(menu, handle);
	}

/* aux */
	if (_bfile_gets(bfile, sbuf, SFILE_BUFLEN, '\0') == 0) {
		goto ERROR;
	}
	sed_SetAux(sed, sfile_FindAuxFunc(sfile, sbuf, &handle));
	if (is_lnf) {
		if (handle == -1) {
			handle = sfile_PutAuxFunc(sfile, sbuf, null_funcptr);
		}
		menu_SetAuxHandle(menu, handle);
	}

	ted_GotoPosition(sed, sed_GetCRow(sed), sed_GetCCol(sed));

	/* send BDM_SCROLL to adjust border lights (suppressed in sf_loadwin) */
	bord_Do(sed, BDM_SCROLL, NULL, NULL);

	if (sfile->alloc == SED_ALLOC) {
		sd_alloc(sed, FALSE);
	}

	return(TRUE);	

ERROR:
	sed_Close(sed);
	return(FALSE);
}
