/*
	sdmoufrm.c  6/23/89

	% sedmou_Framer

	The framer mouse handler.

	C-scape 3.1
	Copyright (c) 1986, 1987, 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	07/20/89 jdc	added if (fld > -1) to sed_SetMouseCode(sed, MOU_CLICK)
*/

#include <stdio.h>
#include "cscape.h"

#include "scancode.h"		/* for MOU codes */

unsigned sedmou_Framer(sed, msg, mev)
	sed_type sed;			/* the sed window */
	int msg;				/* a mouse message */
	mev_struct *mev;		/* the mouse event */
/*
	Messages a mouse handler receives when its window is current
	MEV_REQUEST			someone else wants to be it
	MEV_STARTEVENT
	MEV_EVENT
	MEV_ENDEVENT

	Messages a mouse handler receives when its window is not current
	MEV_STARTOFFER		not current, mouse entered
	MEV_OFFER			not current, event in win
	MEV_ENDOFFER		not current, mouse left

*/
{
	int 	 fld, x;
	ocbox 	 mbox;

	switch(msg){
	case MEV_STARTOFFER:	   	/* we're not the current window */
		win_SetDebounced(sed, mev_IsButtonDown(mev));
		/* no break, fall through */

	case MEV_OFFER:				/* we're not the current window */
		/* same as Click (except for bobs) */

		/* Test if event occurred (button pressed) */
		if (!mev_IsButtonDown(mev)) {

			win_SetDebounced(sed, FALSE);
			mev_ClearEvent(mev);	/* Don't accept it */
		}
		else {
			/* Get Baton before GotoField Changes it */
			x = sed_GetBaton(sed);

			/* accept the event */
			win_SetDebounced(sed, TRUE);

			/* figure out where in the selected sed we want to jump to */
			mbox.toprow = mbox.botrow = mev_GetRow(mev) + sed_GetYoffset(sed);
			mbox.leftcol = mbox.rightcol = mev_GetCol(mev) + sed_GetXoffset(sed);

			if ((fld = sed_FindField(sed, &mbox, OAK_DOWN)) != -1) {
				if (fld != sed_GetFieldNo(sed)) {
				sed_GotoField(sed, fld);
				}
			}

		/* Set our mousecode to tell us that the mouse was clicked
			   when our field function is eventually called
				if (fld > -1) {
					sed_SetMouseCode(sed, MOU_CLICK);
				}
			*/

			/* omit the usual bob checks, we're a framer */

			if (x == BOB_DOWN) {
				/* we have a pulldown , tell it to quit */
				/* Clear the event in order to return a scancode */
				mev_ClearEvent(mev); 
				return(MOU_THERE);
			}
		}
		break;

	case MEV_ENDOFFER: 		  		/* we're not the current window */
	case MEV_ENDEVENT: 		  		/* we're the current window */
		win_SetDebounced(sed, mev_IsButtonDown(mev));
		break;

	case MEV_STARTEVENT:
		win_SetDebounced(sed, mev_IsButtonDown(mev));
		/* no break, fall through */

	case MEV_EVENT:					/* we're the current window */
		/* same as Click */

		/* Test if event occurred (button pressed) */
		if (!mev_IsButtonDown(mev)) {

			if (win_GetDebounced(sed)) {
				sed_SetMouseCode(sed, MOU_CLICK);
				win_SetDebounced(sed, FALSE);
				return(MOU_HERE);
			}
			win_SetDebounced(sed, FALSE);
		}
		else {
			win_SetDebounced(sed, TRUE);

			mbox.toprow = mbox.botrow = mev_GetRow(mev) + sed_GetYoffset(sed);
			mbox.leftcol = mbox.rightcol = mev_GetCol(mev) + sed_GetXoffset(sed);

			/* sed_FindField finds the best field in the given box */ 
			if ((fld = sed_FindField(sed, &mbox, OAK_DOWN)) != -1) {
				if (fld != sed_GetFieldNo(sed)) {
					sed_GotoField(sed, fld);
				}
			}

		/* Set our mousecode to tell us that the mouse was clicked
				   when our field function is eventually called.
				if (fld > -1) {
					sed_SetMouseCode(sed, MOU_CLICK);
				}
		*/

			/* Return MOU_HERE as a scancode to kb_Read */
			return(MOU_HERE);
		}
		break;

	case MEV_REQUEST:
		/*  Another window was selected by the mouse. Ignore it. */

		sed_SetMouseCode(mev_GetWin(mev), MOU_IGNORE);

		return(MOU_IGNORE);
	}

	return(MOU_IGNORE);		/* Ignore this mouse event */
}
