/*
	sdmougck.c  6/22/89

	% sedmou_GreedyClick

	A click, keep control mousehandler

	C-scape 3.1
	Copyright (c) 1986, 1987, 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

#include <stdio.h>
#include "cscape.h"

#include "scancode.h"		/* for MOU codes */

unsigned sedmou_GreedyClick(sed, msg, mev)
	sed_type sed;			/* The sed window */
	int msg;				/* a mouse message */
	mev_struct *mev;	/* the mouse event */
/*
	A mouse handler for pop-ups.
	This mouse handler prevents all other windows from getting
	mouse events while it is active.
	It is used for creating popup windows that require attention.

	(uses sedmou_Click for most of its work)
*/
{
	switch(msg){
	case MEV_STARTCUR:
		/* Trap all mouse events while we're the current window 
			we could be a bob so use our Ancestor.
		*/
		disp_TrapMouse(sed_GetAncestor(sed));
		break;

	case MEV_STOPCUR:
		disp_TrapMouseOff();
		break;

	case MEV_STARTOFFER:
	case MEV_ENDOFFER:
	case MEV_OFFER:
		if (disp_IsTrappedMouse()) {
			/* only respond to offers if trapping is on */

			/* if the event is within our window, pass it up to mou_Click */
			if (mev_GetRow(mev) >= 0 && mev_GetCol(mev) >=0 &&
				mev_GetRow(mev) < win_GetHeight(sed) && 
				mev_GetCol(mev) < win_GetWidth(sed) ) {

				return(sedmou_Click(sed, msg, mev));
			}
			else {
				mev_ClearEvent(mev);
			}
		}
		else {
			mev_ClearEvent(mev);
		}
		break;

	case MEV_REQUEST:
		if (disp_IsTrappedMouse()) {
			/* only respond to requests if trapping is on */
			return(sedmou_Click(sed, msg, mev));
		}
		else {
			mev_ClearEvent(mev);
		}
		break;

	case MEV_STARTEVENT:
		win_SetDebounced(sed, mev_IsButtonDown(mev));
		/* no break, fall through */

	case MEV_ENDEVENT:
	case MEV_EVENT:
		if (disp_IsTrappedMouse()) {
			/* only respond to events if trapping is on */

			/* If the event is inside our window send it to mou_Click
				otherwise ignore it (it can be outside our window, 
				because we've trapped all the messages
			*/
			if (mev_GetRow(mev) >= 0 && mev_GetCol(mev) >=0 &&
				mev_GetRow(mev) < win_GetHeight(sed) && 
				mev_GetCol(mev) < win_GetWidth(sed) ) {

				return(sedmou_Click(sed, msg, mev));
			}
			else {
				if (!mev_IsButtonDown(mev)) {
					win_SetDebounced(sed, FALSE);
				}
				else {
					if (!win_GetDebounced(sed)) {
						win_SetDebounced(sed, TRUE);

					/* mouse has been clicked outside the window,
					   return MOU_THERE so that the popup can be removed */
						return(MOU_THERE);
					}
				}
			}
		}
		else {
			mev_ClearEvent(mev);
		}
	}

	return(MOU_IGNORE);		/* Ignore this mouse event */
}


