/*
	sdload.c

	% sfile_LoadSed, sf_loadsed, sf_savesed

	C-scape 3.1
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

#include "sed.h"
#include "sfile.h"
#include "sfilpriv.h"
#include "sedwinod.h"
#include "ufuncobj.h"
#include "teddecl.h"

OSTATIC objreq_func (sdwinreq_save);

void sedwin_SaveInit()
{
	sdwinreq_savefptr = sdwinreq_save;
	win_SaveInit();
	ufunc_SaveInit();
}

boolean sfile_SaveSed(sfile, sed, name)
	sfile_type	sfile;
	sed_type	sed;
	char		*name;
{
	sedwin_SaveInit();

#ifdef WILL_THEY_REALLY_READ_THE_README
	oslist_Put(sfile->oslist_array[FSYM_CS], "sedwin_Class", &sedwin_Class);
	oslist_Put(sfile->oslist_array[FSYM_CS], "sledwin_Class", &sledwin_Class);
	oslist_Put(sfile->oslist_array[FSYM_CS], "ufunc_Class", &ufunc_Class);
#endif

	return(sfile_SaveObj(sfile, sed, name));
}

int sdwinreq_save(objdata, msg, indata, outdata)
	VOID *objdata;
	int msg;				/* message */
	VOID *indata;			/* message input data */
	VOID *outdata;			/* message output data */
{
	sed_type sed;
	sfile_type sfile;
	bfile_type	bfile;
	char *s[3], *sbuf;
	
	sed = sedod_GetSelf((sedwin_od *)objdata);
	sfile = (sfile_type)indata;

	if (!win_DoRaw(&((sedwin_od *)objdata)->wd, msg, indata, outdata)) {
		return(FALSE);
	}

	bfile = sfile->bfile;
	sbuf = sfile->buf;

	/* menu info: */
	if (!sf_savemenu(sfile, sed_GetMenu(sed))) {
		return(FALSE);
	}

/* sed info:
		back, fore, high, label, 
		move method, special, ox
*/

	/* if there is an funcname iarray pull names that way,
		else search off func directly 
	*/
	if (menu_GetFuncNameA(sed_GetMenu(sed)) == NULL) {
		s[0] = (sed_GetMoveMethod(sed) == FNULL) ? "" : sfile_FindMoveMethodName(sfile, sed_GetMoveMethod(sed)); 
		s[1] = (sed_GetSpecial(sed) == FNULL) ? "" : sfile_FindSpecialName(sfile, sed_GetSpecial(sed));
		s[2] = (sed_GetAux(sed) == FNULL) ? "" : sfile_FindAuxName(sfile, sed_GetAux(sed));
	}
	else {
		s[0] = sed_GetMoveMethodName(sed, sfile);
		s[1] = sed_GetSpecialName(sed, sfile);
		s[2] = sed_GetAuxName(sed, sfile);
	}
	sprintf(sbuf, "%d %d %d %d\n%s\n%s\n%s\n", 
		sed_GetLabel(sed), 
		(int)win_GetAttr(sed), (int)sed_GetRegAttr(sed), (int)sed_GetSelAttr(sed),
		fsym_NullCheck(s[0]), fsym_NullCheck(s[1]), fsym_NullCheck(s[2]));

	if (!bfile_Write(bfile, sbuf, strlen(sbuf))) {
		return(FALSE);
	}

	return(TRUE);
}

