/*
	sdsrch.c   	10/28/86

	% sed_SearchMerge

	int sed_SearchMerge(sed, c)
	Goes to the next field in the sed that starts with character c.
	Case and leading spaces are ignored.
	Returns fieldno if a match is found.
	Else returns (-1).

	C-scape 3.1
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/11/86	jmd		added register variables
	11/15/86	jmd		added protected fields
	12/16/86	jmd		skips over writable fields
	12/28/86	jmd		just searchs for alphanumerics.

	... add a case sensitivity flag?	
	... find first char
	... find first Upper Case char
*/

#include "sed.h"
#include <ctype.h>

int	sed_SearchMerge(sed, c)
	sed_type sed;
	char	 c;
/*	
	Find the next field whose merge begins with the given character.
	Leading Spaces are ignored.	 Case is ignored.
  	Return the field number if a field is found
  	Return (-1) if no field starts with the character.
	Ignores writable fields and protected fields.
*/
{
	register	int i, fld;
	menu_type	menu;
	char *p;

	menu = sed_GetMenu(sed);

	for (i = 0; i < menu_GetFieldCount(menu); i++) {
		fld = (i + sed_GetFieldNo(sed) + 1) % menu_GetFieldCount(menu);

		/* ignore writable and protected fields */
		if (menu_GetRecordLen(menu, fld) == 0 && 
			!menu_IsProtected(menu, fld)) {

			/* find first non alphanumeric character in the merge */
			p = menu_GetFieldMerge(menu, fld);
			while (!(isalnum(*p)) && (*p != '\0'))
				p++;
	
			/* compare the character with the merge character */
			if ((*p != '\0') && (toupper(*p) == toupper(c) ) ) {
				return(fld);
			}
		}
	}

	return(-1);
}

