/*
	sled.h

	% The sled window class header

	C-scape 3.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	12/12/88 jdc	new! from the bobsled_Class
	12/13/88 jdc	added:  #define sled_funcs bob_funcs
	 3/29/89 jmd	converted seds to 'pure' objects, moved sleddata to sled_xd
	 4/28/89 jdc	added sled_GetFieldRow()
	 7/15/89 ted	Converted '_func' prototypes from typedef to macro.
	 8/04/89 gam	renamed this file to sled.h. Used to be sledwin.h
	 8/05/89 gam	added protection/marking for rows and columns
	 8/21/89 jdc	broke out close code into sledwin_Close (LNF)
	 8/25/89 gam	removed obsolete sld_rpnt() and sled_fkey() prototypes
*/

extern class_func	(sledwin_Class);

#define SLEDWM_LASTMSG	(SEDWM_LASTMSG + 0)

typedef struct {

	sed_xd			wd;						/* sed superclass xdata */

	unsigned int	offset;
	unsigned int	size;
	xarray			xa;
	iarray			cflags;			/* Column special flags */

	byte			regattr;
	byte			selattr;

	unsigned int	height;
	unsigned int	width;

	VOID 		   *blank;

} sled_xd;

#define sled_getxd(sled)			 	((sled_xd *) sed_getxd(sled))

#define SLED_BSIZE 50
#define SLED_ASIZE 10

extern sed_type		sled_ReallyOpen(_arg4(menu_type, int, spc_fptr, class_fptr));
extern boolean 		sled_Init(_arg3(sed_type, int, spc_fptr));
extern void			sledwin_Close(_arg1(sed_type));

extern boolean	sled_Remap(_arg2(sed_type, int));
extern boolean	sled_remapper(_arg2(sed_type, int));

extern VOID *sled_GetColVar(_arg3(sed_type, int, int));
extern void  sled_SetColVar(_arg4(sed_type, int, int, VOID *));

extern boolean	sled_InsertRows(_arg3(sed_type, int, int));
extern void		sled_DeleteRows(_arg3(sed_type, int, int));

/* the sled remapping code is now contained completely in spc_Sled */
#define sled_funcs bob_funcs
extern spc_func (spc_Sled);

/* macros */

#define	sled_Open(m, h, s)		sled_ReallyOpen(m, h, s, sledwin_Class)

#define	sled_Repaint(sed)		sled_Remap(sed, 0)

#define sled_GetOffset(sed) 	((sled_getxd(sed))->offset)
#define sled_GetColSize(sed) 	((sled_getxd(sed))->size)
#define sled_GetHeight(sed) 	((sled_getxd(sed))->height)
#define sled_GetWidth(sed)	 	((sled_getxd(sed))->width)
#define sled_GetXa(sed)	 		((sled_getxd(sed))->xa)
#define sled_GetBlank(sed)	 	((sled_getxd(sed))->blank)

#define sled_SetOffset(sed, o) 	((sled_getxd(sed))->offset = (o))
#define sled_SetColSize(sed, c) ((sled_getxd(sed))->size = (c))
#define sled_SetHeight(sed, h) 	((sled_getxd(sed))->height = (h))
#define sled_SetWidth(sed, w)	((sled_getxd(sed))->width = (w))
#define sled_SetXa(sed, x)	 	((sled_getxd(sed))->xa = (x))
#define sled_SetBlank(sed, b)	((sled_getxd(sed))->blank = (b))


/* Get the "current" row in the column array */
#define sled_GetRow(sed) \
	(sed_GetGridRow(sed, sed_GetFieldNo(sed)) + sled_GetOffset(sed))

/* Get the row in the column array that a particular field displays */
#define sled_GetFieldRow(sed, fldno) \
	(sed_GetGridRow(sed, fldno) + sled_GetOffset(sed))

#define sled_IsLastRow(sed) \
	((sled_GetRow(sed) >= sled_GetColSize(sed) - 1 ) ? TRUE : FALSE)

#define sed_GetSled(sed, sled) \
	bob_Do(sed_GetFieldBob(sed, sed_GetFieldNo(sed)), SEDBM_GETSED, NULL, (VOID *)sled)
