/*
	sledprot.c

	% sled protection, marking, and support routines

	C-scape 3.1
	Copyright (c) 1989, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/04/89 gam	Created
*/

#include "sed.h"
#include "sadecl.h"
#include "sldwinod.h"
#include "sled.h"
#include "sledprot.h"

void sled_GetMarkAttr(sed, regular, selected)
	sed_type	sed;
	byte		*regular;
	byte		*selected;
{
	*regular = sled_GetRegAttr(sed);
	*selected = sled_GetSelAttr(sed);
}

void sled_SetMarkAttr(sed, regular, selected)
	sed_type	sed;
	byte		regular;
	byte		selected;
{
	sled_SetRegAttr(sed, regular);
	sled_SetSelAttr(sed, selected);
}

void sled_setrowflags(sed, row, torf, mask)
	sed_type	sed;
	int			row;
	boolean		torf;
	int			mask;
{
	int	value;

	if (torf) {
		value = sled_getrowspecial(sed, row) | mask;
	}
	else {
		value = sled_getrowspecial(sed, row) & (mask^0xFFFF);
	}

	sled_setrowspecial(sed, row, value);
}

void sled_setcolflags(sed, col, torf, mask)
	sed_type	sed;
	int			col;
	boolean		torf;
	int			mask;
{
	int			value;

	if (torf) {
		value = ia_Get(sled_getcflags(sed), col) | mask;
	}
	else {
		value = ia_Get(sled_getcflags(sed), col) & (mask^0xFFFF);
	}

	ia_Put(sled_getcflags(sed), col, value);
}
