/*
	tedfile.c    

	% ted_ReadFile, ted_WriteFile

	file read and write for text editting

	C-scape 3.1
	Copyright (c) 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	---------------------
	 2/07/89 jmd	added cast to omalloc call
	 3/24/89 jmd	added sed_ macros
*/

#include "ted.h"

#define _TED_BUFSIZE	1000

long ted_ReadFile(sed, fp)
	sed_type sed;
	FILE* fp;
/*
	fills the sed's textbuffer from fp.

	returns: number of characters read or -1L if error
*/
{
	unsigned int size;
	char *buf;

	sed_ClearTB(sed);
	buf = (char *) omalloc(CSA_TEDREADF, _TED_BUFSIZE);
	rewind(fp);

	while ((size = fread(buf, 1, _TED_BUFSIZE, fp)) != 0) { 
		sed_SetTB(sed, buf, size);
	}
	/* get rid of the extra '\n' */
	if ((sed_GetTextbuf(sed))->len == 1) {
		menu_DelRowTB(sed_GetMenu(sed), tb_GetRow(sed_GetTextbuf(sed)), 0);
	}
	sed_RewindTB(sed);
	ofree(CSA_TEDREADF, buf);
	return(TRUE);
}

long ted_WriteFile(sed, fp, mode)
	sed_type sed;
	FILE* fp;
	int mode;
/*
	writes the sed's textbuffer to fp

	returns: number of characters written or -1L if error
*/
{
	unsigned int ref, llen;
	long clen = 0L, cursor = 0L;
	bbc_type bbc;
	bbpeek_struct bp;
	int row, col, dlen;

	ted_GetPosition(sed, &row, &col);

	ref = ted_GetRefresh(sed);
	ted_SetRefresh(sed, TED_NOREFRESH);

	rewind(fp);
	sed_RewindTB(sed);

	bbc = (sed_GetTextbuf(sed))->bbc;

	do {
		llen = ted_GetLineLen(sed);
		bp.b = bbc->b;
		bp.off = bp.b->off;
		bp.len = (long)llen;
		do {
			dlen = bbpeek(&bp);
			fwrite(bp.p, 1, dlen, fp);
			bp.off += dlen;
			bp.len -= (long)dlen;
			
		} while (bp.len > 0L);

		if (mode == TED_HARD && !ted_IsHardLine(sed)) {
			fwrite("\n", 1, 1, fp);
			clen++;
		}
		clen += llen;
		cursor += (long)llen;

	} while (ted_GotoCursor(sed, cursor));

	ted_GotoPosition(sed, row, col);

	ted_SetRefresh(sed, ref);

	return(clen);
}
