/*
	tedsrch.c  

	% ted_Search

	text editting search functions

	C-scape 3.1
	Copyright (c) 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/10/88 jdc	created

	 2/08/89 jmd	added args
	 3/24/89 jmd	added sed_ macros
	05/23/89 jdc	made tb_setcursor menu_setcursor
*/

#include "ted.h"

typedef struct {

	char *s;
	char *pattern;
	int  cmp_len;
	int  match_len;
	int  more;
	int  mode;

} scomp_struct;

int search_compare(_arg1(scomp_struct*));

boolean ted_Search(sed, pattern, mode)
	sed_type sed;
	char *pattern;
	int mode;
{	
	tb_type tb;
	long cursor;
	scomp_struct scs;
	bbpeek_struct bp;
	int srch, i, done, dlen;
	
	tb = sed_GetTextbuf(sed);

	bp.b = tb->bbc->b;
	bp.off = bp.b->off + tb_GetCursor(tb);
	bp.len = tb->size;

	cursor = tb->cursor;
	scs.pattern = pattern;
	scs.more = 0;
	scs.mode = mode;
		
	for (done = FALSE; !done;) {
		for (i = 0, dlen = bbpeek(&bp); i < dlen;) {
			scs.s = bp.p + i;
	 		scs.cmp_len = dlen - i;
			if ((srch = search_compare(&scs)) == TED_MATCH) {
	       		done = TRUE;
				break;
			}
			else if (srch == TED_NOMATCH) {
				if (mode & TED_FORWARD) {
					i++;
					bp.off++;
					if (scs.more > 0) {
						bp.off -= scs.more;
						scs.more = 0;
						break;
					}
    				if (i >= dlen) {
						break;
					}
				}
				else {
					i--;
					bp.off--;
					if (scs.more > 0) {
						bp.off -= scs.more;
						scs.more = 0;
						break;
					}
    				if (bp.off < 0) {
						break;
					}
				}
			}
			else {	  			/* TED_MORE */
				bp.off += dlen - i;
				break;
			}
		}
		if (dlen <= 0) {
			return(FALSE);
		}
		cursor += i;
 	}

	if (mode & TED_AFTER) {
		cursor += scs.match_len;
	}
	else if (mode & TED_BEFORE) {
		cursor--;
	}
 	tb->cursor = cursor;
	menu_setcursor(sed_GetMenu(sed));
 	ted_GotoPosition(sed, tb_GetRow(tb), tb_GetCol(tb));

	return(TRUE);
}						

int search_compare(scs)
	scomp_struct *scs;
{
	char *p, *s;
	int len, more;

	for (p = scs->pattern + scs->more, s = scs->s, len = scs->cmp_len,
		more = 0;
		; 
		p++, s++, more++, len--) { 

		if (*p == '\0') {
			scs->match_len = scs->more + more;
			return(TED_MATCH);
		}
		else if (len == 0)  {
			scs->more += more;
			return(TED_MORE);
		}
		else if (*p != *s) {
			return(TED_NOMATCH);
		}
	}
}	

