/*
	tedword.c  

	 % ted_FindWord

	text editting right and left word function

	C-scape 3.1
	Copyright (c) 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/09/88 jdc 	created

	 3/24/89 jmd	added sed_ macros
	05/23/89 jdc	made tb_setcursor menu_setcursor
*/

#include "ted.h"

boolean ted_FindWord(sed, mode)
	sed_type sed;
	int mode;
{
	tb_type tb;
	long cursor;
	bbpeek_struct bp;
	int i, val, done, dlen;

	tb = sed_GetTextbuf(sed);
	cursor = tb->cursor;

	bp.b = tb->bbc->b;
	bp.off = bp.b->off + tb_GetCursor(tb);
	bp.len = tb->size;

	for (done = FALSE, val = FALSE; !done;) {
		for (i = 0, dlen = bbpeek(&bp); ;) {
			if (is_whitespace(bp.p[i]) == val) {
				if (mode == TED_FORWARD) {
					i++;
					bp.off++;
					if (i > dlen) {
						break;
					}
				}
				else {
					i--;
					bp.off--;
					if (bp.off < 0) {
						break;
					}
				}
			}
			else if (val == FALSE) {
				val = TRUE;
				break;
			}
			else {
				done = TRUE;
				break;
			}
		}
		if (dlen == 0) {
			return(FALSE);
		}
		cursor += i;
	}

	tb->cursor = cursor;
	menu_setcursor(sed_GetMenu(sed));
	ted_GotoPosition(sed, tb_GetRow(tb), tb_GetCol(tb));

	return(TRUE);
}














