/*
	ufncload.c

	% ufuncreq_load

	C-scape 3.1
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

#include "sed.h"
#include "ufuncobj.h"
#include "ufuncod.h"
#include "sfile.h"
#include "sfilpriv.h"

OSTATIC objreq_func (ufuncreq_load);

void ufunc_LoadInit()
{
	ufuncreq_loadfptr = ufuncreq_load;
}

ufunc_fptr ufunc_unresolved_fptr = FNULL;

int ufuncreq_load(objdata, msg, indata, outdata)
	VOID *objdata;
	int msg;				/* message */
	VOID *indata;			/* message input data */
	VOID *outdata;			/* message output data */
{
	int handle;
	ufuncopen_struct ufuncopen;
	sfile_type sfile;
	bob_type bob;

	oak_notused(outdata);
	oak_notused(msg);

	sfile = (sfile_type)indata;
	bob = ufuncod_GetSelf((ufunc_od *)objdata);

	/* ufunc info:
		idata, ufunc name
	*/
	_bfile_gets(sfile->bfile, sfile->buf, SFILE_BUFLEN, '\0');
	ufuncopen.idata = atoi(sfile->buf);

	_bfile_gets(sfile->bfile, sfile->buf, SFILE_BUFLEN, '\0');

	if (strcmp(sfile->buf, FSYM_NULLSTR) == 0) {
		ufuncopen.ufunc = FNULL;
	}
	else if ((ufuncopen.ufunc = sfile_FindUserFunc(sfile, sfile->buf, &handle)) == FNULL) {
		ufuncopen.ufunc = ufunc_unresolved_fptr;
	}

	if (handle == -1) {
		handle = sfile_PutUserFunc(sfile, sfile->buf, ufuncopen.ufunc);
	}
	ufuncbob_SetFuncHandle(bob, handle);

	return(obj_Do(bob, OBJM_INIT, &ufuncopen, NULL));
}
