/*
	ufncsave.c

	% ufuncreq_save

	C-scape 3.1
	Copyright (c) 1988, 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

#include "sed.h"
#include "ufuncobj.h"
#include "ufuncod.h"
#include "sfile.h"
#include "sfilpriv.h"

OSTATIC objreq_func (ufuncreq_save);

void ufunc_SaveInit()
{
	ufuncreq_savefptr = ufuncreq_save;
}

int ufuncreq_save(objdata, msg, indata, outdata)
	VOID *objdata;
	int msg;				/* message */
	VOID *indata;			/* message input data */
	VOID *outdata;			/* message output data */
{
	ufunc_od *ufdp;
	sfile_type sfile;
	bob_type bob;
	char *name;

	oak_notused(outdata);
	oak_notused(msg);

	ufdp = (ufunc_od *)objdata;
	sfile = (sfile_type)indata;
	bob = ufuncod_GetSelf(ufdp);

	/* ufunc info:
		idata, ufunc name
	*/
	name = (ufuncbob_GetFuncHandle(bob) == -1) ? 
		((ufdp->ufunc == FNULL) ? "" : sfile_FindUserName(sfile, ufdp->ufunc))
		: ufunc_GetUserName(bob, sfile);

	sprintf(sfile->buf, "%d\n%s\n", ufdp->idata, fsym_NullCheck(name));

	return(bfile_Write(sfile->bfile, sfile->buf, strlen(sfile->buf)));
}

char *ufunc_FindUserName(bob, sfile)
	bob_type bob;
	sfile_type sfile;
/*
*/
{
	ufuncopen_struct ufuncopen;

	bob_Do(bob, UFUNCBM_GETUFUNC, NULL, &ufuncopen);

	return((ufuncbob_GetFuncHandle(bob) == -1) ? 
		sfile_FindUserName(sfile, ufuncopen.ufunc) 
		: ufunc_GetUserName(bob, sfile));
}
