/*
	ufuncobj.h

	% header for ufunc bob object class

	C-scape 3.1
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

 	Revision History:
	-----------------
	12/11/88 jmd	removed ufd_struct (no longer needed)
	04/23/89 jdc	put the ufuncopen_struct in here
	 7/15/89 ted	Converted '_func' prototypes from typedef to macro.
	 8/04/89 jdc	added unresolved_func definition
*/

#define ufunc_func(fname)			int fname(_arg2(VOID *, int))
typedef ufunc_func ((*ufunc_fptr));

extern obj_type ufunc_Open(_arg2(ufunc_fptr, int));

#define	bob_IsUfunc(bob)			obj_Who(bob, ID_UFUNC)

extern class_func	(ufunc_Class);

/*** Ufunc bob messages ***/
#define UFUNCBM_GETUFUNC	(WINM_LASTMSG + 1)		/* (ufuncopen_struct *) */
#define UFUNCBM_LASTMSG		(WINM_LASTMSG + 2)

/* creation data for ufunc bob */

typedef struct {
	
	ufunc_fptr 	ufunc;
	int		 	idata;
	
} ufuncopen_struct;

/* The ufunc bob public data structure */

typedef struct {

	bob_xd	cd;					/* bob object xdata */
	int		funcname;			/* function name handle for LNF */

} ufunc_xd;

#define ufuncbob_GetFuncHandle(bob)		\
		(((ufunc_xd *)bob_getxd(bob))->funcname)

#define ufuncbob_SetFuncHandle(bob, h)	\
		(((ufunc_xd *)bob_getxd(bob))->funcname = (h))

/* Request funcs */

extern classinit_func (ufunc_LoadInit);
extern classinit_func (ufunc_SaveInit);

extern ufunc_fptr ufunc_unresolved_fptr;

